package tools;

import cartago.*;
import cartago.tools.inspector.AgentMarker;
import cartago.tools.inspector.ArtifactMarker;
import cartago.tools.inspector.Marker;
import cartago.tools.inspector.WorkspaceScene;
import fr.uga.pddl4j.encoding.CodedProblem;
import fr.uga.pddl4j.parser.Parser;
import fr.uga.pddl4j.planners.Planner.Name;
import fr.uga.pddl4j.planners.ProblemFactory;
import fr.uga.pddl4j.planners.statespace.AbstractStateSpacePlanner;
import fr.uga.pddl4j.planners.statespace.StateSpacePlannerFactory;
import fr.uga.pddl4j.util.Plan;
import jacamo.platform.Cartago;
import jacamo.project.JaCaMoProject;
import jacamo.project.JaCaMoWorkspaceParameters;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
// //        1                    2.0                        3.0                            3.0                           2.1                      3.1                          3.1
// goal("level0",_,plan(_,[goal("mount_1",_,plan(_,[goal("deliver_1",_,"noplan"), goal("attach_1",_,"noplan")])), goal("mount_2",_,plan(_,[goal("deliver_2",_,"noplan"), goal("attach_2",_,"noplan")]))])).


public class Planner extends Artifact{


    /*
    The operation buildPlan will take the pddl files and generate a string plan as an output thanks to OpFeedbackParam
     */
    @OPERATION
    public void buildPlan(String domainPath, String problemPath, OpFeedbackParam<Object> exePlans) throws IOException, InterruptedException, UnknownArtifactException, OperationException {
    	
        // PDDL files to be triggerd domain and problem
        File domain = new File("src\\agt\\pddl\\"+domainPath);
        File problem = new File("src\\agt\\pddl\\"+problemPath);
        
        if (!domain.exists() || !problem.exists()) {
            defineObsProperty("planner", "Erroe...Check if both files exists");
		}else {

        // the method that will run them
        final StateSpacePlannerFactory stateSpacePlannerFactory = StateSpacePlannerFactory.getInstance();
        final Name plannerName = AbstractStateSpacePlanner.DEFAULT_PLANNER;
        final AbstractStateSpacePlanner planner = stateSpacePlannerFactory.getPlanner(plannerName);

        // Creates the problem factory
        final ProblemFactory factory = ProblemFactory.getInstance();
        factory.parse(domain, problem);

        // Encodes and instantiates the problem in a compact representation
        final CodedProblem pb = factory.encode();
        final Plan plan = planner.search(pb);

        Parser parse =new Parser();
        parse.parseProblem(problem);
        String problemName = parse.getProblem().getName().toString();

        // Create a String variable to set a plan which generated by the planner.
        StringBuilder sb = new StringBuilder();
        String planToString = "+!"+problemName+" : true <- ";
        
        sb.append(planToString);

        List<String> constants = pb.getConstants();
        List<String> listOfMatchedArt = new ArrayList<String>();


        for (int i = 0 ; i< plan.size();i++){
            String action = plan.actions().get(i).getName();
            int numOfParam = plan.actions().get(i).getArity();
            sb.append(action+"( ");

            for (int j = 0; j < numOfParam; j++){
                int keyOfParam = plan.actions().get(i).getValueOfParameter(j);
                String param = constants.get(keyOfParam);

                sb.append(" "+param+" ");
                StringBuilder comma = j == numOfParam - 1 ? sb.append(" ") : sb.append(",");

                try {
                    if (!lookupArtifact(param).toString().isEmpty() ){
                        listOfMatchedArt.add(param);
                    }
                } catch (OperationException e) {
                    // This exception is empty because it cause an error which will stop the loop
                    // but it means also that the param will not be considered as an artifact name.
                    // also it means will not match the existing artifact when we pass param in lookupArtifact(param)
                }

            }

            if(i == plan.size() - 1 ){
                if (listOfMatchedArt.size() == 1){
                    sb.append(")[artifact_name(\""+listOfMatchedArt.get(0)+"\")]\n");
                }else {
                    sb.append(")\n");
                }
            }else{
                if (listOfMatchedArt.size() == 1){
                    sb.append(")[artifact_name(\""+listOfMatchedArt.get(0)+"\")];\n");
                }else {
                    sb.append(");\n");
                }
            }
            listOfMatchedArt.clear();
        }
        
        sb.append(".");
        String res = sb.toString();
        exePlans.set(res);
        }
      
    }



}
